/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the FlowPreviewRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &FlowPreviewRequest{}

// FlowPreviewRequest struct for FlowPreviewRequest
type FlowPreviewRequest struct {
	// List of sources to be used
	Sources []string `json:"sources,omitempty"`
	// List of DPI operations to be applied to sources defined above
	Operations []OperationRequest `json:"operations,omitempty"`
}

// NewFlowPreviewRequest instantiates a new FlowPreviewRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewFlowPreviewRequest() *FlowPreviewRequest {
	this := FlowPreviewRequest{}
	return &this
}

// NewFlowPreviewRequestWithDefaults instantiates a new FlowPreviewRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewFlowPreviewRequestWithDefaults() *FlowPreviewRequest {
	this := FlowPreviewRequest{}
	return &this
}

// GetSources returns the Sources field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *FlowPreviewRequest) GetSources() []string {
	if o == nil {
		var ret []string
		return ret
	}
	return o.Sources
}

// GetSourcesOk returns a tuple with the Sources field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *FlowPreviewRequest) GetSourcesOk() ([]string, bool) {
	if o == nil || IsNil(o.Sources) {
		return nil, false
	}
	return o.Sources, true
}

// HasSources returns a boolean if a field has been set.
func (o *FlowPreviewRequest) HasSources() bool {
	if o != nil && IsNil(o.Sources) {
		return true
	}

	return false
}

// SetSources gets a reference to the given []string and assigns it to the Sources field.
func (o *FlowPreviewRequest) SetSources(v []string) {
	o.Sources = v
}

// GetOperations returns the Operations field value if set, zero value otherwise.
func (o *FlowPreviewRequest) GetOperations() []OperationRequest {
	if o == nil || IsNil(o.Operations) {
		var ret []OperationRequest
		return ret
	}
	return o.Operations
}

// GetOperationsOk returns a tuple with the Operations field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FlowPreviewRequest) GetOperationsOk() ([]OperationRequest, bool) {
	if o == nil || IsNil(o.Operations) {
		return nil, false
	}
	return o.Operations, true
}

// HasOperations returns a boolean if a field has been set.
func (o *FlowPreviewRequest) HasOperations() bool {
	if o != nil && !IsNil(o.Operations) {
		return true
	}

	return false
}

// SetOperations gets a reference to the given []OperationRequest and assigns it to the Operations field.
func (o *FlowPreviewRequest) SetOperations(v []OperationRequest) {
	o.Operations = v
}

func (o FlowPreviewRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o FlowPreviewRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.Sources != nil {
		toSerialize["sources"] = o.Sources
	}
	if !IsNil(o.Operations) {
		toSerialize["operations"] = o.Operations
	}
	return toSerialize, nil
}

type NullableFlowPreviewRequest struct {
	value *FlowPreviewRequest
	isSet bool
}

func (v NullableFlowPreviewRequest) Get() *FlowPreviewRequest {
	return v.value
}

func (v *NullableFlowPreviewRequest) Set(val *FlowPreviewRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableFlowPreviewRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableFlowPreviewRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFlowPreviewRequest(val *FlowPreviewRequest) *NullableFlowPreviewRequest {
	return &NullableFlowPreviewRequest{value: val, isSet: true}
}

func (v NullableFlowPreviewRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFlowPreviewRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
